//+------------------------------------------------------------------+
//|                                                      HotKeys.mq4 |
//|                                       Copyright 2016, Investsoft |
//|                                         http://www.investsoft.pl |
//+------------------------------------------------------------------+
#property copyright "Copyright 2016, Investsoft"
#property link      "http://www.investsoft.pl"
#property version   "1.00"
#property indicator_chart_window
#property strict
#property description "Keys 1 through 9 change timeframes from 1 minute to Monthly"

#import "User32.dll"
   int   GetAncestor(int hwnd, int gaFlags);
   int   PostMessageW(int hWnd,int Msg,int wParam,int lParam);
#import

#define MT4_WMCMD_PERIOD_D1         33134
#define MT4_WMCMD_PERIOD_H1         33135
#define MT4_WMCMD_PERIOD_H4         33136
#define MT4_WMCMD_PERIOD_M1         33137
#define MT4_WMCMD_PERIOD_M5         33138
#define MT4_WMCMD_PERIOD_M15        33139
#define MT4_WMCMD_PERIOD_M30        33140
#define MT4_WMCMD_PERIOD_W1         33141
#define MT4_WMCMD_PERIOD_MN         33334

#define WM_COMMAND                  0x111

#define KEY_MONTHLY 49
#define KEY_WEEKLY 50
#define KEY_DAILY 51
#define KEY_4HOUR 52
#define KEY_1HOUR 53
#define KEY_30MIN 54
#define KEY_15MIN 55
#define KEY_5MIN 56
#define KEY_1MIN 57


//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int OnInit()
  {
   return(INIT_SUCCEEDED);
  }
  
//+------------------------------------------------------------------+
//| Indicator deinitialization function                              |
//+------------------------------------------------------------------+
void OnDeinit(const int reason)
  {
//---
   Comment("");
  }
  
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int OnCalculate(const int rates_total,
                const int prev_calculated,
                const datetime &time[],
                const double &open[],
                const double &high[],
                const double &low[],
                const double &close[],
                const long &tick_volume[],
                const long &volume[],
                const int &spread[])
  {
//--- return value of prev_calculated for next call
   return(rates_total);
  }
//+------------------------------------------------------------------+
//| ChartEvent function                                              |
//+------------------------------------------------------------------+
void OnChartEvent(const int id,
                  const long &lparam,
                  const double &dparam,
                  const string &sparam)
  {
//---


   if(id==CHARTEVENT_KEYDOWN)
     {
      switch(int(lparam))
        {
         case KEY_WEEKLY:  PostMessageW(GetAncestor(WindowHandle(_Symbol, _Period),2), WM_COMMAND, MT4_WMCMD_PERIOD_W1, 0);
         break;
         case KEY_DAILY:   PostMessageW(GetAncestor(WindowHandle(_Symbol, _Period),2), WM_COMMAND, MT4_WMCMD_PERIOD_D1, 0);
         break;
         case KEY_4HOUR:   PostMessageW(GetAncestor(WindowHandle(_Symbol, _Period),2), WM_COMMAND, MT4_WMCMD_PERIOD_H4, 0);
         break;
         case KEY_1HOUR:   PostMessageW(GetAncestor(WindowHandle(_Symbol, _Period),2), WM_COMMAND, MT4_WMCMD_PERIOD_H1, 0);
         break;
         case KEY_5MIN:    PostMessageW(GetAncestor(WindowHandle(_Symbol, _Period),2), WM_COMMAND, MT4_WMCMD_PERIOD_M5, 0);
         break;
         case KEY_30MIN:   PostMessageW(GetAncestor(WindowHandle(_Symbol, _Period),2), WM_COMMAND, MT4_WMCMD_PERIOD_M30, 0);
         break;
         case KEY_15MIN:   PostMessageW(GetAncestor(WindowHandle(_Symbol, _Period),2), WM_COMMAND, MT4_WMCMD_PERIOD_M15, 0);
         break;
         case KEY_MONTHLY: PostMessageW(GetAncestor(WindowHandle(_Symbol, _Period),2), WM_COMMAND, MT4_WMCMD_PERIOD_MN, 0);
         break;
         case KEY_1MIN:    PostMessageW(GetAncestor(WindowHandle(_Symbol, _Period),2), WM_COMMAND, MT4_WMCMD_PERIOD_M1, 0);
         break;
        }
      ChartRedraw();
     }
  }
//+------------------------------------------------------------------+
